
;	ORG 0x2600 ; MO
	ORG 0xA000 ; TO
	INCLUDE exo2_final.asm

_main

	# Print "decrunching" message (and check app is running)
	LDY #message
	BSR msg

	# Disable interupts (and annoying curor blink)
	ORCC #0x55

	BSR waitkey

	LDA #0xFF
	LDX #black
	LBSR #0xEC00 ; Set palette

	LDY #clrscr
	BSR msg

	# Switch to "pixel" screen RAM
	;SWI
	;FCB 6
	LDA 0xE7C3
	ORA #1
	STA 0xE7C3

	# Actually decrunch, FORME
	LDY #0x5F40
	LDU #forme-1
	LBSR exo2

	# Switch to "color" screen RAM
	;SWI
	;FCB 4
	LDA 0xE7C3
	ANDA #0xFE
	STA 0xE7C3

	# ... and COLOR
	LDY #0x5F40
	LDU #color-1
	LBSR exo2

	LDA #0xFF
	LDX #palette
	LBSR #0xEC00 ; Set palette

	# Wait for user to press a key before moving to next pic
	#BSR waitkey

	#LDY #resscr
	#BSR msg

	; back to menu
	RTS

;===========================================

waitkey
	;SWI
	;FCB 0xC
	LBSR #0xE806
	BEQ waitkey
	RTS

msg
	LDB ,Y+
	;SWI
	;FCB 2
	LBSR #0xE803
	TSTB
	BNE msg
	RTS

# Welcome message
message
	FCB 0xC
	FCC "Forever 2019 realtime compo"
	
	FCB 0xA,0xA,0xA,0xA,0xA,0xD,0x20,0x1B,0x4F # 0x73
	FCN "  Alien Omelette"

# Clear the screen to black (including border)
clrscr
	;FCB 0x1B,0x5E ; BITMAP 16
	FCB 0x1B,0x5A ; 40col
	;FCB 0x1B,0x59 ; Bitmap 4

# RESET the screen to sane colors and text size
resscr
	FCB 0x1B,0x70,0x1B,0x47,0x1B,0x65,0xC,0x0

	INCLUDEBIN FORME.dat
forme

	INCLUDEBIN COLOR.dat
color

black
	FCB 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	FCB 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
palette
	; 8B4L
	;FCB 0x01,0x12,0x02,0x23,0x03,0x34,0x05,0x67,0x06,0x89,0x08,0xBC,0x0F,0xFF,0x03,0x22
	;FCB 0x04,0x33,0x07,0x66,0x0B,0xAA,0x01,0x03,0x01,0x07,0x01,0x0B,0x05,0x3A,0x0A,0x8C

	; MADDEUCH
	;FDB 0x000,0x11F,0x0F0,0x0FF,0xF11,0xF0F,0xFF1,0xFFF
	;FDB 0x111,0x11F,0X1F1,0x1FF,0xF51,0xF1F,0xFF1,0x15F

	; GNFISH
	;FDB 0x000,0x610,0x920,0xC30,0xF40,0xF50,0xF60,0xF71
	;FDB 0xFFF,0x2AA,0x266,0x558,0x435,0x103,0x721,0x554

	; RoadParty
	;FDB 0x620,0x000,0x9BC,0x007,0x777,0x285,0x733,0x8BE
	;FDB 0x244,0xFC9,0x11C,0xFFF,0x021,0x302,0x58B,0x014
	;FDB 512,0,1126,2,819,306,1041,1711
	;FDB 17,2708,11,4095,16,257,1421,18

	; Invaders
	;FDB 0xFFF,0x000,0x100,0x101,0x000,0x111,0x222,0x333
	;FDB 0x444,0x555,0x666,0x777,0x888,0x999,0xAAA,0xBBB

	; Omelette
	FDB 0xFFF,0x000,0x05A,0xB50,0x11C,0x012,0x061,0x0CC,0x005,0,0,0,0,0,0,0

	END _main
